#ifndef _PRPROGRESS_H_
#define _PRPROGRESS_H_

/** This class is to be derived from to get some kind of progress indication during certain operations (like loading/saving) in a presentation. */

class PrProgress
{
 protected:
  int _range;

 public:
  PrProgress(int range=100);

  int range();

  /** This method is called with different progress states between 0 and 100. */
  virtual void progress(int i)=0; // *****************************
  
  /** Some presentations need to hide (and show) the progress bar explicitly */
  virtual void hide() {};
};

#endif
