#ifndef _VECTOR_H_
#define _VECTOR_H_

#include "compound.h"

/** The vector is the simples implementation of the compound class. Elements of different types may be inserted in a vector.
 */
class Vector : public Compound
{
 private:

 public:
  /** creates an empty vector
   */
  Vector();

  /** copies a vector v
   */
  Vector(const Vector& v);

  /** creates a vector of String objects from a line of characters, using the SPACE as a separator
   */
  Vector(char*);

  /** returns the n'th element (starting with 0)
   */
  Element * operator[](int n);

  virtual ostream & print(int,ostream&) const;
  virtual void flush(const char*) const;
  virtual Element * copy() const;

};

#endif
